package de.unibielefeld.cebitec.gi.algogr.exl2;

/**
 * Backward Algorithm.
 * 
 * @param <State>
 *            state type
 * @param <Alphabet>
 *            type of emission alphabet
 */
public class Backward<State, Alphabet> {

    private double[][] b;

    /**
     * Method implementing the Backward Algorithm.
     * 
     * @param hmm
     *            HMM
     * @param x
     *            emission sequence
     * @return full probability P(x) of emission sequence x
     */
    public double run(HMM<State, Alphabet> hmm, Alphabet[] x) {

        // access required HMM data structures
        double[][] A = hmm.getTransitionMatrix();
        double[][] E = hmm.getEmissionMatrix();
        State[] Q = hmm.getStates();
        double[] alpha = hmm.getBeginDistribution();

        /*
         * BACKWARD ALGORITHM
         */

        // initialize table of b variables
        this.b = new double[x.length][Q.length];

        /*
         * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         * Exercise 2: Implement the Backward algorithm by correctly filling the
         * initialized table of b variables!
         * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         */

        // START

        // INITIALIZATION (i=L)
        // TODO implement the following statement:
        // b_k(L) = 1 for all k

        // RECURSION (i=L-1,...,1)
        // TODO implement the following statement:
        // b_k(i) = \sum_l (a_{k,l} * e_l(x_{i+1}) * b_l(i+1))

        // TERMINATION
        // TODO implement the following statement:
        // P(x) = \sum_l (a_{begin state, l} * e_l(x_1) b_l(1))

        // END
        double P_x = 0;

        // return P(x)
        return P_x;
    }

    /**
     * Getter for b variables.
     * 
     * @return b variables computed in run() function
     */
    public double[][] getVariables() {
        return this.b;
    }
}
